//////////////////////////////////////////////////////////////////////////////////////////
// stdafx.cpp : source file that includes just the standard includes.
// VersInfoEx.pch will be the pre-compiled header.
// stdafx.obj will contain the pre-compiled type information.
//////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#ifdef _ATL_STATIC_REGISTRY         // (std COM/ShlExt)
  #include <statreg.h>              // (std COM/ShlExt)
#endif                              // (std COM/ShlExt)

$MODULEID;      // (embed module-id timestamp and copyright string into object code)

//////////////////////////////////////////////////////////////////////////////////////////
// Portable Executable type:   return empty string if file is not an executable file
//
// PROGRAMMING NOTE: we currently don't care to know the specific type of PE file
// that it is. All we care about is whether it's a 64-bit binary or 32-bit binary.

CString  PEType( LPCTSTR pszFilename )
{
    ASSERT(                pszFilename );
    CString  strFilename = pszFilename;
    ASSERT( !strFilename.IsEmpty() );

    HANDLE  hFile  = CreateFile
    (
        strFilename,                // LPCTSTR  lpFileName,
        FILE_GENERIC_READ,          // DWORD    dwDesiredAccess,
        0                           // DWORD    dwShareMode,
            | FILE_SHARE_READ
            | FILE_SHARE_WRITE
            | FILE_SHARE_DELETE
        ,
        NULL,                       // LPSECURITY_ATTRIBUTES  lpSecurityAttributes,
        OPEN_EXISTING,              // DWORD    dwCreationDisposition,
        FILE_ATTRIBUTE_NORMAL,      // DWORD    dwFlagsAndAttributes,
        NULL                        // HANDLE   hTemplateFile
    );

    CString  strPEType;

    if (hFile && INVALID_HANDLE_VALUE != hFile)
    {
        IMAGE_DOS_HEADER  doshdr;
        IMAGE_NT_HEADERS  nthdrs;
        DWORD             dwBytesRead;

        VERIFY( ReadFile( hFile, &doshdr, sizeof( IMAGE_DOS_HEADER ), &dwBytesRead, NULL ));

        if (IMAGE_DOS_SIGNATURE == doshdr.e_magic)
        {
            VERIFY( SetFilePointer( hFile, doshdr.e_lfanew, NULL, FILE_BEGIN ) == doshdr.e_lfanew );
            VERIFY( ReadFile( hFile, &nthdrs, sizeof( IMAGE_NT_HEADERS ), &dwBytesRead, NULL ));

            if (IMAGE_NT_SIGNATURE == nthdrs.Signature)
            {
                if (nthdrs.FileHeader.Characteristics & IMAGE_FILE_EXECUTABLE_IMAGE)
                {
                    CString  str3264;
                    CString  strSubsystem;
                    CString  strExtension;

                    if (IMAGE_FILE_MACHINE_I386 == nthdrs.FileHeader.Machine)
                        str3264 = _T("32");
                    else if (IMAGE_FILE_MACHINE_AMD64 == nthdrs.FileHeader.Machine)
                        str3264 = _T("64");

                    if (IMAGE_SUBSYSTEM_WINDOWS_GUI == nthdrs.OptionalHeader.Subsystem)
                        strSubsystem = _T(" Windows GUI Program");
                    else if (IMAGE_SUBSYSTEM_WINDOWS_CUI == nthdrs.OptionalHeader.Subsystem)
                        strSubsystem = _T(" Console Application");

                    if (nthdrs.FileHeader.Characteristics & IMAGE_FILE_DLL)
                        strExtension = _T(" Extension");

                    strPEType.Format( _T("%s-bit%s%s"),
                        str3264, strSubsystem, strExtension );
                }
            }
        }

        VERIFY( CloseHandle( hFile ));
    }

    return strPEType;
}

//////////////////////////////////////////////////////////////////////////////////////////
// Shell GetFileInfo Typename           (in case the file is not an PE file)

static CString  GetSHFileTypename( LPCTSTR pszFilename )
{
    ASSERT( pszFilename );

    CString     strTypename;
    SHFILEINFO  fi;

    if (SHGetFileInfo( pszFilename, 0, &fi, sizeof( fi ), SHGFI_TYPENAME ))
        strTypename = fi.szTypeName;
    else
        strTypename = _T("Unknown file type");

    return strTypename;
}

//////////////////////////////////////////////////////////////////////////////////////////
// Get a string we can display to the user that identifies what type of file it is

CString  GetFileTypeString( LPCTSTR pszFilename )
{
    CString strFileType;
    if ((strFileType = PEType( pszFilename )).IsEmpty())
        strFileType = GetSHFileTypename( pszFilename );
    return strFileType;
}

//////////////////////////////////////////////////////////////////////////////////////////
